# Copyright (C) 2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

# * The software is provided "as is" without any warranty, neither express
#   nor implied.
# * In no event will the author be held liable for any damage(s) arising
#   from the use of the software.
# * Redistribution of the software is allowed only in unmodified form.
# * Permission is granted to use the software solely for personal private
#   and non-commercial purposes.
# * An individuals use of the software in his or her capacity or function
#   as an agent, (independent) contractor, employee, member or officer of
#   a business, corporation or organization (commercial or non-commercial)
#   does not qualify as personal private and non-commercial purpose.
# * Without written approval from the author the software must not be used
#   for a business, for commercial, corporate, governmental, military or
#   organizational purposes of any kind, or in a commercial, corporate,
#   governmental, military or organizational environment of any kind.

MODE = static

.SUFFIXES:

all: CRYPTSP.CMD CRYPTBASE.CMD PCWUM.CMD

clean:
	ERASE CRYPTSP.EXP CRYPTSP.IMP CRYPTSP.LIB CRYPTSP.OBJ CRYPTSP.TMP
	ERASE CRYPTBASE.EXP CRYPTBASE.LIB CRYPTBASE.OBJ CRYPTBASE.TMP
	ERASE DETOUR.EXP DETOUR.LIB DETOUR.OBJ DETOUR.TMP
	ERASE PCWUM.EXP PCWUM.LIB PCWUM.OBJ PCWUM.TMP

clobber: clean
	ERASE CRYPTSP.COM CRYPTSP.DLL CRYPTSP.EXE
	ERASE CRYPTBASE.COM CRYPTBASE.DLL CRYPTBASE.EXE
	ERASE PCWUM.COM PCWUM.DLL PCWUM.EXE

CRYPTSP.CMD: CRYPTSP.COM CRYPTSP.DLL CRYPTSP.EXE
	CALL <<"$(MAKEDIR)\$@"
REM Copyright  2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>
"$(MAKEDIR)\CRYPTSP.COM"
ECHO %ERRORLEVEL%
"$(MAKEDIR)\CRYPTSP.EXE"
ECHO %ERRORLEVEL%
COPY /Y NUL: "$(MAKEDIR)\CRYPTSP.DLL"
"$(MAKEDIR)\CRYPTSP.COM"
ECHO %ERRORLEVEL%
"$(MAKEDIR)\CRYPTSP.EXE"
ECHO %ERRORLEVEL%
ERASE "$(MAKEDIR)\CRYPTSP.DLL"
"$(MAKEDIR)\CRYPTSP.COM"
ECHO %ERRORLEVEL%
"$(MAKEDIR)\CRYPTSP.EXE"
ECHO %ERRORLEVEL%
EXIT /B
<<NOKEEP

!IF "$(MODE)" == "static"
CRYPTSP.EXE: CRYPTSP.LIB CRYPTSP.OBJ DETOUR.OBJ
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:KERNEL32.LIB /DEPENDENTLOADFLAG:0x4000 /DYNAMICBASE /ENTRY:MainCRTStartup /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OUT:$@ /RELEASE /SUBSYSTEM:CONSOLE /VERSION:0.815 $**

CRYPTSP.COM: CRYPTSP.LIB CRYPTSP.OBJ
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:KERNEL32.LIB /DYNAMICBASE /ENTRY:MainCRTStartup /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OUT:$@ /RELEASE /SUBSYSTEM:CONSOLE /VERSION:0.815 $**

CRYPTSP.OBJ: DETOUR.MAK
	CL.EXE /Brepro /c /Fo$@ /GAFy /nologo /Ox /Tc<< /W4 /Zl
// Copyright  2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

#define RtlCheckSignatureInFile SystemFunction035

__declspec(dllimport)
BOOL	WINAPI	RtlCheckSignatureInFile(LPCWSTR Filename);

__declspec(noreturn)
VOID	CDECL	MainCRTStartup(VOID)
{
	// https://msdn.microsoft.com/en-us/library/ms682658.aspx
	// https://msdn.microsoft.com/en-us/library/ms679360.aspx

	ExitProcess(RtlCheckSignatureInFile(L"C:\\Windows\\Explorer.exe") ? ERROR_SUCCESS : GetLastError());
}
<<NOKEEP
!ELSEIF "$(MODE)" == "dynamic"
CRYPTSP.EXE: CRYPTSP.OBJ DETOUR.OBJ
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:KERNEL32.LIB /DEPENDENTLOADFLAG:0x4000 /DYNAMICBASE /ENTRY:MainCRTStartup /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OUT:$@ /RELEASE /SUBSYSTEM:CONSOLE /VERSION:0.815 $**

CRYPTSP.COM: CRYPTSP.OBJ
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:KERNEL32.LIB /DYNAMICBASE /ENTRY:MainCRTStartup /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OUT:$@ /RELEASE /SUBSYSTEM:CONSOLE /VERSION:0.815 $**

CRYPTSP.OBJ: DETOUR.MAK
	CL.EXE /Brepro /c /Fo$@ /GAFy /nologo /Ox /Tc<< /W4 /Zl
// Copyright  2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

// https://msdn.microsoft.com/en-us/library/ms684179.aspx

#ifndef LOAD_LIBRARY_SEARCH_SYSTEM32
#define LOAD_LIBRARY_SEARCH_SYSTEM32	0x00000800UL
#endif

__declspec(noreturn)
VOID	CDECL	MainCRTStartup(VOID)
{
	FARPROC	fp;
	DWORD	dwError = ERROR_SUCCESS;
#if 0
	// https://msdn.microsoft.com/en-us/library/ms683199.aspx

	HMODULE	hAdvAPI32 = GetModuleHandleW(L"AdvAPI32.dll");
#else
	// https://msdn.microsoft.com/en-us/library/ms684179.aspx

	HMODULE	hAdvAPI32 = LoadLibraryExW(L"AdvAPI32.dll", NULL, LOAD_LIBRARY_SEARCH_SYSTEM32);
#endif
	if (hAdvAPI32 == NULL)

		// https://msdn.microsoft.com/en-us/library/ms679360.aspx

		dwError = GetLastError();
	else
	{	// https://msdn.microsoft.com/en-us/library/ms683212.aspx

		fp = GetProcAddress(hAdvAPI32, "SystemFunction035");

		if (fp == NULL)
			dwError = GetLastError();
		else
			if (!fp(L"C:\\Windows\\Explorer.exe"))
				dwError = GetLastError();
#if 1
		// https://msdn.microsoft.com/en-us/library/ms683152.aspx

		if (!FreeLibrary(hAdvAPI32))
			dwError = GetLastError();
#endif
	}

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(dwError);
}
<<NOKEEP
!ELSE
!ERROR Only MODE=static and MODE=dynamic supported!
!ENDIF

CRYPTSP.DLL: CRYPTSP.TMP
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:KERNEL32.LIB /DEFAULTLIB:USER32.LIB /DLL /DYNAMICBASE /ENTRY:_DllMainCRTStartup /EXPORT:CheckSignatureInFile /IGNORE:4197 /IMPLIB:$*.IMP /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OUT:$@ /RELEASE /SUBSYSTEM:WINDOWS /VERSION:0.815 $**

CRYPTSP.LIB: CRYPTSP.TMP
	LINK.EXE /LIB /BREPRO /DEF /EXPORT:SystemFunction035=CheckSignatureInFile /IGNORE:4197 /NAME:ADVAPI32 /NODEFAULTLIB /NOLOGO /OUT:$@ $**

CRYPTSP.TMP: DETOUR.MAK
	CL.EXE /Brepro /c /Fo$@ /GAFy /nologo /Ox /Tc<< /W4 /wd4100 /Zl
// Copyright  2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

extern	const	IMAGE_DOS_HEADER	__ImageBase;

// https://msdn.microsoft.com/en-us/library/ms682583.aspx

const	LPCSTR	szReason[4] = {"DLL_PROCESS_DETACH\n",
		               "DLL_PROCESS_ATTACH\n",
		               "DLL_THREAD_ATTACH\n",
		               "DLL_THREAD_DETACH\n"};

// https://msdn.microsoft.com/en-us/library/ms682596.aspx

BOOL	WINAPI	_DllMainCRTStartup(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
	LPCSTR			szModule = "<unknown>";
	IMAGE_NT_HEADERS	*ntHeader = (IMAGE_NT_HEADERS *) ((LPBYTE) &__ImageBase + __ImageBase.e_lfanew);
	DWORD			dwRVA = ntHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress;
	DWORD			dwSize = ntHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].Size;

	if ((dwRVA != 0UL) && (dwSize >= sizeof(IMAGE_EXPORT_DIRECTORY)))
	{
		dwRVA = ((IMAGE_EXPORT_DIRECTORY *) ((LPBYTE) &__ImageBase + dwRVA))->Name;
		if (dwRVA != 0UL)
			szModule = (LPCSTR) ((LPBYTE) &__ImageBase + dwRVA);
	}

	// https://msdn.microsoft.com/en-us/library/ms645507.aspx

	return IDOK == MessageBoxExA(HWND_DESKTOP,
	                             szReason[dwReason],
	                             szModule,
	                             dwReason == DLL_PROCESS_ATTACH ? MB_OKCANCEL : MB_OK,
	                             MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT));
}

__declspec(dllexport)
BOOL	WINAPI	CheckSignatureInFile(LPCWSTR Filename)
{
	// https://msdn.microsoft.com/en-us/library/ms680627.aspx

	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);

	return FALSE;
}
<<NOKEEP

CRYPTBASE.CMD: CRYPTBASE.COM CRYPTBASE.DLL CRYPTBASE.EXE
	CALL <<"$(MAKEDIR)\$@"
REM Copyright  2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>
"$(MAKEDIR)\CRYPTBASE.COM"
ECHO %ERRORLEVEL%
"$(MAKEDIR)\CRYPTBASE.EXE"
ECHO %ERRORLEVEL%
COPY /Y NUL: "$(MAKEDIR)\CRYPTBASE.DLL"
"$(MAKEDIR)\CRYPTBASE.COM"
ECHO %ERRORLEVEL%
"$(MAKEDIR)\CRYPTBASE.EXE"
ECHO %ERRORLEVEL%
ERASE "$(MAKEDIR)\CRYPTBASE.DLL"
"$(MAKEDIR)\CRYPTBASE.COM"
ECHO %ERRORLEVEL%
"$(MAKEDIR)\CRYPTBASE.EXE"
ECHO %ERRORLEVEL%
EXIT /B
<<NOKEEP

!IF "$(MODE)" == "static"
CRYPTBASE.EXE: CRYPTBASE.OBJ DETOUR.OBJ DETOUR.LIB
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:ADVAPI32.LIB /DEFAULTLIB:KERNEL32.LIB /DEPENDENTLOADFLAG:0x4000 /DYNAMICBASE /ENTRY:MainCRTStartup /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OUT:$@ /RELEASE /SUBSYSTEM:CONSOLE /VERSION:0.815 $**

CRYPTBASE.COM: CRYPTBASE.OBJ DETOUR.LIB
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:ADVAPI32.LIB /DEFAULTLIB:KERNEL32.LIB /DYNAMICBASE /ENTRY:MainCRTStartup /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OUT:$@ /RELEASE /SUBSYSTEM:CONSOLE /VERSION:0.815 $**

CRYPTBASE.OBJ: DETOUR.MAK
	CL.EXE /Brepro /c /Fo$@ /GAFy /nologo /Ox /Tc<< /W4 /Zl
// Copyright  2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

// https://msdn.microsoft.com/en-us/library/hh310515.aspx

#ifndef LOAD_LIBRARY_SEARCH_SYSTEM32
#define LOAD_LIBRARY_SEARCH_SYSTEM32	0x00000800UL
#endif

__declspec(dllimport)
BOOL	WINAPI	SetDefaultDllDirectories(DWORD Flags);

// https://msdn.microsoft.com/en-us/library/aa387694.aspx

#define RtlGenRandom SystemFunction036

__declspec(dllimport)
BOOLEAN	WINAPI	RtlGenRandom(LPVOID Buffer, DWORD Size);

// https://msdn.microsoft.com/en-us/library/aa387693.aspx

#define RtlEncryptMemory SystemFunction040

__declspec(dllimport)
LONG	WINAPI	RtlEncryptMemory(LPVOID Memory, DWORD Size, DWORD Flags);

// https://msdn.microsoft.com/en-us/library/aa387692.aspx

#define RtlDecryptMemory SystemFunction041

__declspec(dllimport)
LONG	WINAPI	RtlDecryptMemory(LPVOID Memory, DWORD Size, DWORD Flags);

__declspec(noreturn)
VOID	CDECL	MainCRTStartup(VOID)
{
	BYTE	cbBuffer[32];
	DWORD	dwError = ERROR_SUCCESS;

	// https://msdn.microsoft.com/en-us/library/hh310515.aspx

	if (!SetDefaultDllDirectories(LOAD_LIBRARY_SEARCH_SYSTEM32))

		// https://msdn.microsoft.com/en-us/library/ms679360.aspx

		dwError = GetLastError();

	// https://msdn.microsoft.com/en-us/library/aa387694.aspx

	RtlGenRandom(cbBuffer, sizeof(cbBuffer));

	// https://msdn.microsoft.com/en-us/library/aa387693.aspx

	RtlEncryptMemory(cbBuffer, sizeof(cbBuffer), 0UL);

	// https://msdn.microsoft.com/en-us/library/aa387692.aspx

	RtlDecryptMemory(cbBuffer, sizeof(cbBuffer), 0UL);

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(dwError);
}
<<NOKEEP
!ELSEIF "$(MODE)" == "dynamic"
CRYPTBASE.EXE: CRYPTBASE.OBJ DETOUR.OBJ
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:KERNEL32.LIB /DEPENDENTLOADFLAG:0x4000 /DYNAMICBASE /ENTRY:MainCRTStartup /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OUT:$@ /RELEASE /SUBSYSTEM:CONSOLE /VERSION:0.815 $**

CRYPTBASE.COM: CRYPTBASE.OBJ
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:KERNEL32.LIB /DYNAMICBASE /ENTRY:MainCRTStartup /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OUT:$@ /RELEASE /SUBSYSTEM:CONSOLE /VERSION:0.815 $**

CRYPTBASE.OBJ: DETOUR.MAK
	CL.EXE /Brepro /c /Fo$@ /GAFy /nologo /Ox /Tc<< /W4 /Zl
// Copyright  2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

// https://msdn.microsoft.com/en-us/library/ms684179.aspx

#ifndef LOAD_LIBRARY_SEARCH_SYSTEM32
#define LOAD_LIBRARY_SEARCH_SYSTEM32	0x00000800UL
#endif

__declspec(noreturn)
VOID	CDECL	MainCRTStartup(VOID)
{
	FARPROC	fp;
	DWORD	dwError = ERROR_SUCCESS;
#if 0
	// https://msdn.microsoft.com/en-us/library/ms683199.aspx

	HMODULE	hAdvAPI32 = GetModuleHandleW(L"AdvAPI32.dll");
#else
	// https://msdn.microsoft.com/en-us/library/ms684179.aspx

	HMODULE	hAdvAPI32 = LoadLibraryExW(L"AdvAPI32.dll", NULL, LOAD_LIBRARY_SEARCH_SYSTEM32);
#endif
	if (hAdvAPI32 == NULL)

		// https://msdn.microsoft.com/en-us/library/ms679360.aspx

		dwError = GetLastError();
	else
	{	// https://msdn.microsoft.com/en-us/library/ms683212.aspx

		fp = GetProcAddress(hAdvAPI32, "SystemFunction036");

		if (fp == NULL)
			dwError = GetLastError();
		else
			fp(&fp, sizeof(fp));

		fp = GetProcAddress(hAdvAPI32, "SystemFunction040");

		if (fp == NULL)
			dwError = GetLastError();
		else
			fp(&fp, sizeof(fp), 0UL);

		fp = GetProcAddress(hAdvAPI32, "SystemFunction041");

		if (fp == NULL)
			dwError = GetLastError();
		else
			fp(&fp, sizeof(fp), 0UL);
#if 1
		// https://msdn.microsoft.com/en-us/library/ms683152.aspx

		if (!FreeLibrary(hAdvAPI32))
			dwError = GetLastError();
#endif
	}

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(dwError);
}
<<NOKEEP
!ELSE
!ERROR Only MODE=static and MODE=dynamic supported!
!ENDIF

CRYPTBASE.DLL: CRYPTBASE.TMP
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:USER32.LIB /DLL /DYNAMICBASE /ENTRY:_DllMainCRTStartup /EXPORT:SystemFunction036 /EXPORT:SystemFunction040 /EXPORT:SystemFunction041 /IGNORE:4197 /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OUT:$@ /RELEASE /SUBSYSTEM:WINDOWS /VERSION:0.815 $**

CRYPTBASE.TMP: DETOUR.MAK
	CL.EXE /Brepro /c /Fo$@ /GAFy /nologo /Ox /Tc<< /W4 /wd4100 /Zl
// Copyright  2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

#define STATUS_NOT_IMPLEMENTED	0xC0000002L

extern	const	IMAGE_DOS_HEADER	__ImageBase;

// https://msdn.microsoft.com/en-us/library/ms682583.aspx

const	LPCSTR	szReason[4] = {"DLL_PROCESS_DETACH\n",
		               "DLL_PROCESS_ATTACH\n",
		               "DLL_THREAD_ATTACH\n",
		               "DLL_THREAD_DETACH\n"};

// https://msdn.microsoft.com/en-us/library/ms682596.aspx

BOOL	WINAPI	_DllMainCRTStartup(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
	LPCSTR			szModule = "<unknown>";
	IMAGE_NT_HEADERS	*ntHeader = (IMAGE_NT_HEADERS *) ((LPBYTE) &__ImageBase + __ImageBase.e_lfanew);
	DWORD			dwRVA = ntHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress;
	DWORD			dwSize = ntHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].Size;

	if ((dwRVA != 0UL) && (dwSize >= sizeof(IMAGE_EXPORT_DIRECTORY)))
	{
		dwRVA = ((IMAGE_EXPORT_DIRECTORY *) ((LPBYTE) &__ImageBase + dwRVA))->Name;
		if (dwRVA != 0UL)
			szModule = (LPCSTR) ((LPBYTE) &__ImageBase + dwRVA);
	}

	// https://msdn.microsoft.com/en-us/library/ms645507.aspx

	return IDOK == MessageBoxExA(HWND_DESKTOP,
	                             szReason[dwReason],
	                             szModule,
	                             dwReason == DLL_PROCESS_ATTACH ? MB_OKCANCEL : MB_OK,
	                             MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT));
}

// https://msdn.microsoft.com/en-us/library/aa387694.aspx

__declspec(dllexport)
BOOLEAN	WINAPI	SystemFunction036(LPVOID Buffer, DWORD Length)
{
	return FALSE;
}

// https://msdn.microsoft.com/en-us/library/aa387693.aspx

__declspec(dllexport)
LONG	WINAPI	SystemFunction040(LPVOID Buffer, DWORD Length, DWORD Flags)
{
	return STATUS_NOT_IMPLEMENTED;
}

// https://msdn.microsoft.com/en-us/library/aa387692.aspx

__declspec(dllexport)
LONG	WINAPI	SystemFunction041(LPVOID Buffer, DWORD Length, DWORD Flags)
{
	return STATUS_NOT_IMPLEMENTED;
}
<<NOKEEP

PCWUM.CMD: PCWUM.COM PCWUM.DLL PCWUM.EXE
	CALL <<"$(MAKEDIR)\$@"
REM Copyright  2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>
"$(MAKEDIR)\PCWUM.COM"
ECHO %ERRORLEVEL%
"$(MAKEDIR)\PCWUM.EXE"
ECHO %ERRORLEVEL%
COPY /Y NUL: "$(MAKEDIR)\PCWUM.DLL"
"$(MAKEDIR)\PCWUM.COM"
ECHO %ERRORLEVEL%
"$(MAKEDIR)\PCWUM.EXE"
ECHO %ERRORLEVEL%
ERASE "$(MAKEDIR)\PCWUM.DLL"
"$(MAKEDIR)\PCWUM.COM"
ECHO %ERRORLEVEL%
"$(MAKEDIR)\PCWUM.EXE"
ECHO %ERRORLEVEL%
EXIT /B
<<NOKEEP

PCWUM.EXE: PCWUM.OBJ DETOUR.OBJ
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:ADVAPI32.LIB /DEFAULTLIB:KERNEL32.LIB /DEPENDENTLOADFLAG:0x4000 /DYNAMICBASE /ENTRY:MainCRTStartup /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OUT:$@ /RELEASE /SUBSYSTEM:CONSOLE /VERSION:0.815 $**

PCWUM.COM: PCWUM.OBJ
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:ADVAPI32.LIB /DEFAULTLIB:KERNEL32.LIB /DYNAMICBASE /ENTRY:MainCRTStartup /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OUT:$@ /RELEASE /SUBSYSTEM:CONSOLE /VERSION:0.815 $**

PCWUM.OBJ: DETOUR.MAK
	CL.EXE /Brepro /c /Fo$@ /nologo /GAFy /Ox /Tc<< /W4 /Zl
// Copyright  2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <perflib.h>

const	GUID	guid = {0, 0, 0, {0, 0, 0, 0, 0, 0, 0, 0}};

__declspec(noreturn)
VOID	CDECL	MainCRTStartup(VOID)
{
	HANDLE	hProvider;

	// https://msdn.microsoft.com/en-us/library/aa373138.aspx

	DWORD	dwError = PerfStartProvider(&guid, NULL, &hProvider);

	if (dwError == ERROR_SUCCESS)

		// https://msdn.microsoft.com/en-us/library/aa373140.aspx

		dwError = PerfStopProvider(hProvider);

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(dwError);
}
<<NOKEEP

PCWUM.DLL: PCWUM.TMP
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:USER32.LIB /DLL /DYNAMICBASE /ENTRY:_DllMainCRTStartup /EXPORT:PerfStartProvider /EXPORT:PerfStopProvider /IGNORE:4197 /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OUT:$@ /RELEASE /SUBSYSTEM:WINDOWS /VERSION:0.815 $**

PCWUM.TMP: DETOUR.MAK
	CL.EXE /Brepro /c /Fo$@ /GAFy /nologo /Ox /Tc<< /W4 /wd4100 /Zl
// Copyright  2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

extern	const	IMAGE_DOS_HEADER	__ImageBase;

// https://msdn.microsoft.com/en-us/library/ms682583.aspx

const	LPCSTR	szReason[4] = {"DLL_PROCESS_DETACH\n",
		               "DLL_PROCESS_ATTACH\n",
		               "DLL_THREAD_ATTACH\n",
		               "DLL_THREAD_DETACH\n"};

// https://msdn.microsoft.com/en-us/library/ms682596.aspx

BOOL	WINAPI	_DllMainCRTStartup(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
	LPCSTR			szModule = "<unknown>";
	IMAGE_NT_HEADERS	*ntHeader = (IMAGE_NT_HEADERS *) ((LPBYTE) &__ImageBase + __ImageBase.e_lfanew);
	DWORD			dwRVA = ntHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress;
	DWORD			dwSize = ntHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].Size;

	if ((dwRVA != 0UL) && (dwSize >= sizeof(IMAGE_EXPORT_DIRECTORY)))
	{
		dwRVA = ((IMAGE_EXPORT_DIRECTORY *) ((LPBYTE) &__ImageBase + dwRVA))->Name;
		if (dwRVA != 0UL)
			szModule = (LPCSTR) ((LPBYTE) &__ImageBase + dwRVA);
	}

	// https://msdn.microsoft.com/en-us/library/ms645507.aspx

	return IDOK == MessageBoxExA(HWND_DESKTOP,
	                             szReason[dwReason],
	                             szModule,
	                             dwReason == DLL_PROCESS_ATTACH ? MB_OKCANCEL : MB_OK,
	                             MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT));
}

// https://msdn.microsoft.com/en-us/library/aa373138.aspx

__declspec(dllexport)
DWORD	WINAPI	PerfStartProvider(LPGUID lpGUID, LPVOID lpCallback, HANDLE *hProvider)
{
	return ERROR_CALL_NOT_IMPLEMENTED;
}

// https://msdn.microsoft.com/en-us/library/aa373140.aspx

__declspec(dllexport)
DWORD	WINAPI	PerfStopProvider(HANDLE hProvider)
{
	return ERROR_CALL_NOT_IMPLEMENTED;
}
<<NOKEEP

DETOUR.LIB: DETOUR.TMP
	LINK.EXE /LIB /BREPRO /DEF /EXPORT:AddDllDirectory /EXPORT:RemoveDllDirectory /EXPORT:SetDefaultDllDirectories /NAME:KERNEL32 /NODEFAULTLIB /NOLOGO /OUT:$@ DETOUR.TMP

DETOUR.TMP: DETOUR.MAK
	CL.EXE /Brepro /c /Fo$@ /Gz /nologo /Tc<< /W4 /wd4100 /X /Zl
// Copyright  2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/hh310513.aspx

__declspec(dllexport)
void *	AddDllDirectory(void *_1)
{
	return 0;
}

// https://msdn.microsoft.com/en-us/library/hh310514.aspx

__declspec(dllexport)
int	RemoveDllDirectory(void *_1)
{
	return 0;
}

// https://msdn.microsoft.com/en-us/library/hh310515.aspx

__declspec(dllexport)
int	SetDefaultDllDirectories(long _1)
{
	return 0;
}
<<NOKEEP

DETOUR.OBJ: DETOUR.MAK
	CL.EXE /Brepro /c /Fo$@ /GAFy /nologo /Tc<< /W4 /wd4047 /Zl
// Copyright  2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

// https://msdn.microsoft.com/en-us/library/ms684179.aspx

#ifndef LOAD_LIBRARY_SEARCH_SYSTEM32_NO_FORWARDER
#define LOAD_LIBRARY_SEARCH_SYSTEM32_NO_FORWARDER	0x00004000UL
#endif

#ifndef _WIN64
static	DWORD	__security_cookie = 3141592654UL;

// https://msdn.microsoft.com/en-us/library/9a89h429.aspx

extern	LPVOID	__safe_se_handler_table[];
extern	BYTE	__safe_se_handler_count;

// https://msdn.microsoft.com/en-us/library/ms680328.aspx

const	struct	_IMAGE_LOAD_CONFIG_DIRECTORY_32
{
	DWORD	Size;
	DWORD	TimeDateStamp;
	WORD	MajorVersion;
	WORD	MinorVersion;
	DWORD	GlobalFlagsClear;
	DWORD	GlobalFlagsSet;
	DWORD	CriticalSectionDefaultTimeout;
	DWORD	DeCommitFreeBlockThreshold;
	DWORD	DeCommitTotalFreeThreshold;
	DWORD	LockPrefixTable;
	DWORD	MaximumAllocationSize;
	DWORD	VirtualMemoryThreshold;
	DWORD	ProcessHeapFlags;
	DWORD	ProcessAffinityMask;
	WORD	CSDVersion;
	WORD	DependentLoadFlags;
	DWORD	EditList;
	DWORD	SecurityCookie;
	DWORD	SEHandlerTable;
	DWORD	SEHandlerCount;
	DWORD	GuardCFCheckFunctionPointer;
	DWORD	GuardCFDispatchFunctionPointer;
	DWORD	GuardCFFunctionTable;
	DWORD	GuardCFFunctionCount;
	DWORD	GuardFlags;
	struct	// _IMAGE_LOAD_CONFIG_CODE_INTEGRITY
	{
		WORD	Flags;
		WORD	Catalog;
		DWORD	CatalogOffset;
		DWORD	Reserved;
	} CodeIntegrity;
	DWORD	GuardAddressTakenIatEntryTable;
	DWORD	GuardAddressTakenIatEntryCount;
	DWORD	GuardLongJumpTargetTable;
	DWORD	GuardLongJumpTargetCount;
	DWORD	DynamicValueRelocTable;
	DWORD	CHPEMetadataPointer;
	DWORD	GuardRFFailureRoutine;
	DWORD	GuardRFFailureRoutineFunctionPointer;
	DWORD	DynamicValueRelocTableOffset;
	WORD	DynamicValueRelocTableSection;
	WORD	Reserved2;
	DWORD	GuardRFVerifyStackPointerFunctionPointer;
	DWORD	HotPatchTableOffset;
	DWORD	Reserved3;
	DWORD	EnclaveConfigurationPointer;
	DWORD	VolatileMetadataPointer;
	DWORD	GuardEHContinuationTable;
	DWORD	GuardEHContinuationCount;
} _load_config_used = {sizeof(_load_config_used),
                       'NULL',		// = 2011-08-24 19:09:00 UTC
                       _MSC_VER / 100,
                       _MSC_VER % 100,
                       0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL,
                       0U,
                       LOAD_LIBRARY_SEARCH_SYSTEM32_NO_FORWARDER,
                       0UL,
                       &__security_cookie,
                       __safe_se_handler_table,
                       &__safe_se_handler_count,
                       0UL, 0UL, 0UL, 0UL, 0UL};
#else
static	DWORD64	__security_cookie = 3141592653589793241ULL >> 16;

// https://msdn.microsoft.com/en-us/library/ms680328.aspx

const	struct	_IMAGE_LOAD_CONFIG_DIRECTORY_64
{
	DWORD	Size;
	DWORD	TimeDateStamp;
	WORD	MajorVersion;
	WORD	MinorVersion;
	DWORD	GlobalFlagsClear;
	DWORD	GlobalFlagsSet;
	DWORD	CriticalSectionDefaultTimeout;
	DWORD64	DeCommitFreeBlockThreshold;
	DWORD64	DeCommitTotalFreeThreshold;
	DWORD64	LockPrefixTable;
	DWORD64	MaximumAllocationSize;
	DWORD64	VirtualMemoryThreshold;
	DWORD64	ProcessAffinityMask;
	DWORD	ProcessHeapFlags;
	WORD	CSDVersion;
	WORD	DependentLoadFlags;
	DWORD64	EditList;
	DWORD64	SecurityCookie;
	DWORD64	SEHandlerTable;
	DWORD64	SEHandlerCount;
	DWORD64	GuardCFCheckFunctionPointer;
	DWORD64	GuardCFDispatchFunctionPointer;
	DWORD64	GuardCFFunctionTable;
	DWORD64	GuardCFFunctionCount;
	DWORD	GuardFlags;
	struct	// _IMAGE_LOAD_CONFIG_CODE_INTEGRITY
	{
		WORD	Flags;
		WORD	Catalog;
		DWORD	CatalogOffset;
		DWORD	Reserved;
	} CodeIntegrity;
	DWORD64	GuardAddressTakenIatEntryTable;
	DWORD64	GuardAddressTakenIatEntryCount;
	DWORD64	GuardLongJumpTargetTable;
	DWORD64	GuardLongJumpTargetCount;
	DWORD64	DynamicValueRelocTable;
	DWORD64	CHPEMetadataPointer;
	DWORD64	GuardRFFailureRoutine;
	DWORD64	GuardRFFailureRoutineFunctionPointer;
	DWORD	DynamicValueRelocTableOffset;
	WORD	DynamicValueRelocTableSection;
	WORD	Reserved2;
	DWORD64	GuardRFVerifyStackPointerFunctionPointer;
	DWORD	HotPatchTableOffset;
	DWORD	Reserved3;
	DWORD64	EnclaveConfigurationPointer;
	DWORD64	VolatileMetadataPointer;
	DWORD64	GuardEHContinuationTable;
	DWORD64	GuardEHContinuationCount;
} _load_config_used = {sizeof(_load_config_used),
                       'NULL',		// = 2011-08-24 19:09:00 UTC
                       _MSC_VER / 100,
                       _MSC_VER % 100,
                       0UL, 0UL, 0UL,
                       0ULL, 0ULL, 0ULL, 0ULL, 0ULL, 0ULL,
                       0UL,
                       0U,
                       LOAD_LIBRARY_SEARCH_SYSTEM32_NO_FORWARDER,
                       0ULL,
                       &__security_cookie,
                       0ULL, 0ULL, 0ULL, 0ULL, 0ULL, 0ULL,
                       0UL};
#endif // _WIN64
<<NOKEEP

-DETOUR.OBJ: DETOUR.MAK
	CL.EXE /Brepro /c /Fo$@ /GAFy /nologo /Tc<< /W4 /Zl
// Copyright  2011-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

#ifndef LOAD_LIBRARY_SEARCH_SYSTEM32_NO_FORWARDER
#define LOAD_LIBRARY_SEARCH_SYSTEM32_NO_FORWARDER	0x00004000UL
#endif

#ifndef _WIN64
static	DWORD	__security_cookie = 3141592654UL;

// https://msdn.microsoft.com/en-us/library/9a89h429.aspx

extern	LPVOID	__safe_se_handler_table[];
extern	BYTE	__safe_se_handler_count;

// https://msdn.microsoft.com/en-us/library/ms680328.aspx

const	IMAGE_LOAD_CONFIG_DIRECTORY32	_load_config_used = {sizeof(_load_config_used),
					                     'NULL',		// = 2011-08-24 19:09:00 UTC
					                     _MSC_VER / 100,
					                     _MSC_VER % 100,
					                     0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL,
					                     0U,
					                     LOAD_LIBRARY_SEARCH_SYSTEM32_NO_FORWARDER,
					                     0UL,
					                     &__security_cookie,
					                     __safe_se_handler_table,
					                     &__safe_se_handler_count,
					                     0UL, 0UL, 0UL, 0UL, 0UL};
#else
static	DWORD64	__security_cookie = 3141592653589793241ULL >> 16;

// https://msdn.microsoft.com/en-us/library/ms680328.aspx

const	IMAGE_LOAD_CONFIG_DIRECTORY64	_load_config_used = {sizeof(_load_config_used),
					                     'NULL',		// = 2011-08-24 19:09:00 UTC
					                     _MSC_VER / 100,
					                     _MSC_VER % 100,
					                     0UL, 0UL, 0UL,
					                     0ULL, 0ULL, 0ULL, 0ULL, 0ULL, 0ULL,
					                     0UL,
					                     0U,
					                     LOAD_LIBRARY_SEARCH_SYSTEM32_NO_FORWARDER,
					                     0ULL,
					                     &__security_cookie,
					                     0ULL, 0ULL, 0ULL, 0ULL, 0ULL, 0ULL,
					                     0UL};
#endif // _WIN64
<<NOKEEP
